#!/usr/bin/env python
# -*- coding: utf-8 -*-

import blamlib
import time

class Mini_Chat( blamlib.network.TCP_Server ):
        def on_connect( self, client ):
            """On clientect (new client)"""
            print "Connected %s:%d" %( client.host, client.port )
            client.write( "Clients %d" % len( self.clients ) )

        def on_disconnect( self, client ):
            """Called when a client disclientected"""
            print "Diconnected %s:%d" %( client.host, client.port )

        def handle( self, client, data ):
            """Called when we got data from a client"""
            print "<%s> '%s'" %( ( client.host, client.port ), data.strip() )

            if data == "!cl\n":
                client.write( "client objects: '%s'" % repr( self.clients ) )
                return
            
            for iter_client in self.clients:
                if iter_client != client:
                    iter_client.write( data )
        
    
print "Example app"
net = Mini_Chat( u"", 7000 )
print u"Listing on %s:%d" %( net.host, net.port )
while True:
    net.poll()
    time.sleep( 0.01 )
